# Defter Ayarları Oluşturma/Güncelleme Yapılır

## PUT /Properties

> Defter ayarları yoksa oluşturur varsa günceller.

```json
{"openapi":"3.0.1","info":{"title":"E-Ledger API","version":"v1"},"servers":[{"url":"/eledger"}],"security":[{"Bearer":[]}],"components":{"securitySchemes":{"Bearer":{"type":"http","description":"API anahtar� giriniz","scheme":"Bearer","bearerFormat":"JWT"}},"schemas":{"UpdateELedgerPropertiesCommand":{"type":"object","properties":{"ELedgerProperties":{"$ref":"#/components/schemas/ELedgerProperties"}},"additionalProperties":false},"ELedgerProperties":{"type":"object","properties":{"Nace":{"type":"string","nullable":true},"Creator":{"type":"string","nullable":true},"LineCount":{"type":"integer","format":"int32"},"TaxType":{"$ref":"#/components/schemas/TaxType"},"IsBranch":{"type":"boolean"},"BranchName":{"type":"string","nullable":true},"BranchNumber":{"type":"string","nullable":true},"LedgerPeriod":{"type":"boolean"},"FiscalYearStart":{"type":"string","format":"date-time"},"FiscalYearEnd":{"type":"string","format":"date-time"},"AccountingPeriod":{"$ref":"#/components/schemas/AccountingPeriod"},"SignMethod":{"$ref":"#/components/schemas/SignMethod"},"IsLiquidate":{"type":"boolean"},"LiquidateYearStart":{"type":"string","format":"date-time","nullable":true},"BalanceControl":{"type":"boolean"},"PaymentMethodControl":{"type":"boolean"},"CurrencyCode":{"type":"string","nullable":true},"SplitBillControl":{"type":"boolean"},"DocumentNumberControl":{"type":"boolean"},"AutoNumberControl":{"type":"boolean"},"DateDifferenceValidControl":{"type":"boolean"},"OpeningVoucherControl":{"type":"boolean"},"AutoPaymentMethodControl":{"type":"boolean"},"IsEntryLocked":{"type":"boolean"}},"additionalProperties":false},"TaxType":{"enum":["IncludeTax","ExcludeTax"],"type":"string"},"AccountingPeriod":{"enum":["AccountingPeriod","InterimAccountingPeriod","SpecialAccountingPeriod"],"type":"string"},"SignMethod":{"enum":["SmartCard","Hsm","AccountingSmartCard"],"type":"string"}}},"paths":{"/Properties":{"put":{"tags":["Properties"],"summary":"Defter ayarları yoksa oluşturur varsa günceller.","requestBody":{"description":"","content":{"application/json-patch+json":{"schema":{"$ref":"#/components/schemas/UpdateELedgerPropertiesCommand"}},"application/json":{"schema":{"$ref":"#/components/schemas/UpdateELedgerPropertiesCommand"}},"text/json":{"schema":{"$ref":"#/components/schemas/UpdateELedgerPropertiesCommand"}},"application/*+json":{"schema":{"$ref":"#/components/schemas/UpdateELedgerPropertiesCommand"}}}},"responses":{"200":{"description":"Defter ayarları yoksa oluşturur varsa günceller.","content":{"text/plain":{"schema":{"type":"boolean"}},"application/json":{"schema":{"type":"boolean"}},"text/json":{"schema":{"type":"boolean"}}}},"400":{"description":"Geçersiz İstek | Gönderdiğiniz istekte geçersiz veriler bulunduğu anlamında gelmektedir | Detaylar için <a target=\"_blank\" href=\"https://developer.nilvera.com/hata-kodlari#badrequest-400\">tıklayınız</a>"},"403":{"description":"Yetkisiz Erişim | Bu uca erişmek için gerekli yetkiye sahip olmadığınız durumda dönülür"},"404":{"description":"Parametrede belirtilen kayıt bulunamadığında dönülür | Detaylar için <a target=\"_blank\" href=\"https://developer.nilvera.com/hata-kodlari#notfound-404\">tıklayınız</a>"},"422":{"description":"Gönderdiğiniz istek geçerli fakat iş kuralları gereği geçersiz değerler içerdiğinde dönülür | Detaylar için <a target=\"_blank\" href=\"https://developer.nilvera.com/hata-kodlari#unprocessableentity-422\">tıklayınız</a>"}}}}}}
```

{% tabs %}
{% tab title="C#" %}

```csharp
var options = new RestClientOptions("https://apitest.nilvera.com")
{
    MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("/eledger/Properties", Method.Put);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer <API KEY>");
var body = @"{
    ""ELedgerProperties"": {
        ""Nace"": ""Your Nace Value"",
        ""Creator"": ""Your Creator Value"",
        ""TaxType"": ""IncludeTax"",
        ""LineCount"": 0,
        ""IsBranch"": true,
        ""BranchName"": ""Your Branch Name"",
        ""BranchNumber"": ""Your Branch Number"",
        ""LedgerPeriod"": true,
        ""FiscalYearStart"": ""2024-04-03T11:14:43.050Z"",
        ""FiscalYearEnd"": ""2024-04-03T11:14:43.050Z"",
        ""AccountingPeriod"": ""AccountingPeriod"",
        ""IsLiquidate"": true,
        ""LiquidateYearStart"": ""2024-04-03T11:14:43.050Z""
    }
}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

{% endtab %}

{% tab title="PHP - cURL" %}

```php
<?php
$curl = curl_init();
curl_setopt_array($curl, array(
  CURLOPT_URL => 'https://apitest.nilvera.com/eledger/Properties',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'PUT',
  CURLOPT_POSTFIELDS =>'{
  "ELedgerProperties": {
    "Nace": "string",
    "Creator": "string",
    "TaxType": "IncludeTax",
    "LineCount": 0,
    "IsBranch": true,
    "BranchName": "string",
    "BranchNumber": "string",
    "LedgerPeriod": true,
    "FiscalYearStart": "2024-04-03T11:14:43.050Z",
    "FiscalYearEnd": "2024-04-03T11:14:43.050Z",
    "AccountingPeriod": "AccountingPeriod",
    "IsLiquidate": true,
    "LiquidateYearStart": "2024-04-03T11:14:43.050Z"
  }
}',
  CURLOPT_HTTPHEADER => array(
    'Content-Type: application/json',
    'Authorization: Bearer <API KEY>'
  ),
));
$response = curl_exec($curl);
curl_close($curl);
echo $response;
```

{% endtab %}

{% tab title="NodeJs - Axios" %}

```javascript
const axios = require('axios');
let data = JSON.stringify({
  "ELedgerProperties": {
    "Nace": "string",
    "Creator": "string",
    "TaxType": "IncludeTax",
    "LineCount": 0,
    "IsBranch": true,
    "BranchName": "string",
    "BranchNumber": "string",
    "LedgerPeriod": true,
    "FiscalYearStart": "2024-04-03T11:14:43.050Z",
    "FiscalYearEnd": "2024-04-03T11:14:43.050Z",
    "AccountingPeriod": "AccountingPeriod",
    "IsLiquidate": true,
    "LiquidateYearStart": "2024-04-03T11:14:43.050Z"
  }
});
let config = {
  method: 'put',
  maxBodyLength: Infinity,
  url: 'https://apitest.nilvera.com/eledger/Properties',
  headers: { 
    'Content-Type': 'application/json', 
    'Authorization': 'Bearer <API KEY>'
  },
  data : data
};
axios.request(config)
.then((response) => {
  console.log(JSON.stringify(response.data));
})
.catch((error) => {
  console.log(error);
});
```

{% endtab %}
{% endtabs %}
